Bug 453589 (CVE-2008-2376)

Summary: CVE-2008-2376 ruby: integer overflows in rb_ary_fill() / Array#fill
Product: [Other] Security Response Reporter: Tomas Hoger <thoger>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: tagoh
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2008-07-21 09:29:31 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 451926, 451927, 451928, 451929, 451930, 451931    
Bug Blocks:    

Description Tomas Hoger 2008-07-01 14:07:14 UTC
It was discovered that implementation of Ruby Array's fill method is affected by
a multiple integer overflows.  Problem occurred in rb_ary_fill() function in
array.c and could result in insufficient memory allocations resulting in a heap
overflow.

First patch to address integer overflow condition was added upstream (in 1.8.6
branch) in following commit:

http://svn.ruby-lang.org/cgi-bin/viewvc.cgi?view=rev&revision=13397

That change was insufficient and need to be replaced with following patch:

http://svn.ruby-lang.org/cgi-bin/viewvc.cgi/branches/ruby_1_8_6/array.c?r1=17475&r2=17759

This was applied in 1.8.6-p257:

http://svn.ruby-lang.org/cgi-bin/viewvc.cgi?view=rev&revision=17759

Comment 1 Tomas Hoger 2008-07-01 14:07:52 UTC
Issue was already addressed in Fedora packages in ruby-1.8.6.230-4.

Comment 3 Tomas Hoger 2008-07-02 07:54:50 UTC
Public now via:

  http://www.openwall.com/lists/oss-security/2008/07/02/3

Comment 5 Fedora Update System 2008-07-03 00:16:21 UTC
ruby-1.8.6.230-4.fc8 has been submitted as an update for Fedora 8

Comment 6 Fedora Update System 2008-07-03 03:15:42 UTC
ruby-1.8.6.230-4.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 7 Fedora Update System 2008-07-04 03:40:42 UTC
ruby-1.8.6.230-4.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.